/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ATLANTIS_OPTIONS_H
#define _ATLANTIS_OPTIONS_H

#include <core/core.h>

class AtlantisOptions : public CompOption::Class {
    public:
        enum Options {
            SpeedFactor,
            StartCrabsBottom,
            SchoolSimilarGroups,
            LowPoly,
            CreatureType,
            CreatureColor,
            CreatureNumber,
            CreatureSize,
            PlantType,
            PlantColor,
            PlantNumber,
            PlantSize,
            ShowWater,
            ShowWaterWire,
            ShowGround,
            GroundColor,
            WaterHeight,
            WaterColor,
            GridQuality,
            RenderWaves,
            WaveRipple,
            WaveAmplitude,
            WaveFrequency,
            SmallWaveAmplitude,
            SmallWaveFrequency,
            RescaleWidth,
            RotateLighting,
            LightInclination,
            LightAmbient,
            OptionNum
        };

        enum CreatureType {
            CreatureTypeFishButterflyfish = 0,
            CreatureTypeFishChromis1 = 1,
            CreatureTypeFishChromis2 = 2,
            CreatureTypeFishChromis3 = 3,
            CreatureTypeFishType1 = 4,
            CreatureTypeFishType2 = 5,
            CreatureTypeDolphin = 6,
            CreatureTypeShark = 7,
            CreatureTypeWhale = 8,
            CreatureTypeCrab = 9,
        };

        enum PlantType {
            PlantTypeCoral1 = 0,
            PlantTypeCoral2 = 1,
            PlantTypeAerator = 2,
        };

        #define CreatureTypeFishButterflyfishMask (1 << 0)
        #define CreatureTypeFishChromis1Mask (1 << 1)
        #define CreatureTypeFishChromis2Mask (1 << 2)
        #define CreatureTypeFishChromis3Mask (1 << 3)
        #define CreatureTypeFishType1Mask (1 << 4)
        #define CreatureTypeFishType2Mask (1 << 5)
        #define CreatureTypeDolphinMask (1 << 6)
        #define CreatureTypeSharkMask (1 << 7)
        #define CreatureTypeWhaleMask (1 << 8)
        #define CreatureTypeCrabMask (1 << 9)


        #define PlantTypeCoral1Mask (1 << 0)
        #define PlantTypeCoral2Mask (1 << 1)
        #define PlantTypeAeratorMask (1 << 2)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        AtlantisOptions ();
        virtual ~AtlantisOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        float optionGetSpeedFactor ();
        void optionSetSpeedFactorNotify (ChangeNotify notify);

        bool optionGetStartCrabsBottom ();
        void optionSetStartCrabsBottomNotify (ChangeNotify notify);

        bool optionGetSchoolSimilarGroups ();
        void optionSetSchoolSimilarGroupsNotify (ChangeNotify notify);

        bool optionGetLowPoly ();
        void optionSetLowPolyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetCreatureType ();
        unsigned int optionGetCreatureTypeMask ();
        void optionSetCreatureTypeNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetCreatureColor ();
        void optionSetCreatureColorNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetCreatureNumber ();
        void optionSetCreatureNumberNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetCreatureSize ();
        void optionSetCreatureSizeNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPlantType ();
        unsigned int optionGetPlantTypeMask ();
        void optionSetPlantTypeNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPlantColor ();
        void optionSetPlantColorNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPlantNumber ();
        void optionSetPlantNumberNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPlantSize ();
        void optionSetPlantSizeNotify (ChangeNotify notify);

        bool optionGetShowWater ();
        void optionSetShowWaterNotify (ChangeNotify notify);

        bool optionGetShowWaterWire ();
        void optionSetShowWaterWireNotify (ChangeNotify notify);

        bool optionGetShowGround ();
        void optionSetShowGroundNotify (ChangeNotify notify);

        unsigned short * optionGetGroundColor ();
        unsigned short optionGetGroundColorRed ();
        unsigned short optionGetGroundColorGreen ();
        unsigned short optionGetGroundColorBlue ();
        unsigned short optionGetGroundColorAlpha ();
        void optionSetGroundColorNotify (ChangeNotify notify);

        float optionGetWaterHeight ();
        void optionSetWaterHeightNotify (ChangeNotify notify);

        unsigned short * optionGetWaterColor ();
        unsigned short optionGetWaterColorRed ();
        unsigned short optionGetWaterColorGreen ();
        unsigned short optionGetWaterColorBlue ();
        unsigned short optionGetWaterColorAlpha ();
        void optionSetWaterColorNotify (ChangeNotify notify);

        int optionGetGridQuality ();
        void optionSetGridQualityNotify (ChangeNotify notify);

        bool optionGetRenderWaves ();
        void optionSetRenderWavesNotify (ChangeNotify notify);

        bool optionGetWaveRipple ();
        void optionSetWaveRippleNotify (ChangeNotify notify);

        float optionGetWaveAmplitude ();
        void optionSetWaveAmplitudeNotify (ChangeNotify notify);

        float optionGetWaveFrequency ();
        void optionSetWaveFrequencyNotify (ChangeNotify notify);

        float optionGetSmallWaveAmplitude ();
        void optionSetSmallWaveAmplitudeNotify (ChangeNotify notify);

        float optionGetSmallWaveFrequency ();
        void optionSetSmallWaveFrequencyNotify (ChangeNotify notify);

        bool optionGetRescaleWidth ();
        void optionSetRescaleWidthNotify (ChangeNotify notify);

        bool optionGetRotateLighting ();
        void optionSetRotateLightingNotify (ChangeNotify notify);

        float optionGetLightInclination ();
        void optionSetLightInclinationNotify (ChangeNotify notify);

        float optionGetLightAmbient ();
        void optionSetLightAmbientNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mCreatureTypeMask;
        unsigned int mPlantTypeMask;

};


inline float
AtlantisOptions::optionGetSpeedFactor ()
{
    return mOptions[AtlantisOptions::SpeedFactor].value ().f ();
}

inline void
AtlantisOptions::optionSetSpeedFactorNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::SpeedFactor] = notify;
}

inline bool
AtlantisOptions::optionGetStartCrabsBottom ()
{
    return mOptions[AtlantisOptions::StartCrabsBottom].value ().b ();
}

inline void
AtlantisOptions::optionSetStartCrabsBottomNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::StartCrabsBottom] = notify;
}

inline bool
AtlantisOptions::optionGetSchoolSimilarGroups ()
{
    return mOptions[AtlantisOptions::SchoolSimilarGroups].value ().b ();
}

inline void
AtlantisOptions::optionSetSchoolSimilarGroupsNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::SchoolSimilarGroups] = notify;
}

inline bool
AtlantisOptions::optionGetLowPoly ()
{
    return mOptions[AtlantisOptions::LowPoly].value ().b ();
}

inline void
AtlantisOptions::optionSetLowPolyNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::LowPoly] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetCreatureType ()
{
    return mOptions[AtlantisOptions::CreatureType].value ().list ();
}

inline unsigned int
AtlantisOptions::optionGetCreatureTypeMask ()
{
    return mCreatureTypeMask;
}

inline void
AtlantisOptions::optionSetCreatureTypeNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::CreatureType] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetCreatureColor ()
{
    return mOptions[AtlantisOptions::CreatureColor].value ().list ();
}

inline void
AtlantisOptions::optionSetCreatureColorNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::CreatureColor] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetCreatureNumber ()
{
    return mOptions[AtlantisOptions::CreatureNumber].value ().list ();
}

inline void
AtlantisOptions::optionSetCreatureNumberNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::CreatureNumber] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetCreatureSize ()
{
    return mOptions[AtlantisOptions::CreatureSize].value ().list ();
}

inline void
AtlantisOptions::optionSetCreatureSizeNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::CreatureSize] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetPlantType ()
{
    return mOptions[AtlantisOptions::PlantType].value ().list ();
}

inline unsigned int
AtlantisOptions::optionGetPlantTypeMask ()
{
    return mPlantTypeMask;
}

inline void
AtlantisOptions::optionSetPlantTypeNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::PlantType] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetPlantColor ()
{
    return mOptions[AtlantisOptions::PlantColor].value ().list ();
}

inline void
AtlantisOptions::optionSetPlantColorNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::PlantColor] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetPlantNumber ()
{
    return mOptions[AtlantisOptions::PlantNumber].value ().list ();
}

inline void
AtlantisOptions::optionSetPlantNumberNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::PlantNumber] = notify;
}

inline CompOption::Value::Vector &
AtlantisOptions::optionGetPlantSize ()
{
    return mOptions[AtlantisOptions::PlantSize].value ().list ();
}

inline void
AtlantisOptions::optionSetPlantSizeNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::PlantSize] = notify;
}

inline bool
AtlantisOptions::optionGetShowWater ()
{
    return mOptions[AtlantisOptions::ShowWater].value ().b ();
}

inline void
AtlantisOptions::optionSetShowWaterNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::ShowWater] = notify;
}

inline bool
AtlantisOptions::optionGetShowWaterWire ()
{
    return mOptions[AtlantisOptions::ShowWaterWire].value ().b ();
}

inline void
AtlantisOptions::optionSetShowWaterWireNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::ShowWaterWire] = notify;
}

inline bool
AtlantisOptions::optionGetShowGround ()
{
    return mOptions[AtlantisOptions::ShowGround].value ().b ();
}

inline void
AtlantisOptions::optionSetShowGroundNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::ShowGround] = notify;
}

inline unsigned short *
AtlantisOptions::optionGetGroundColor ()
{
    return mOptions[AtlantisOptions::GroundColor].value ().c ();
}

inline unsigned short
AtlantisOptions::optionGetGroundColorRed ()
{
    return mOptions[AtlantisOptions::GroundColor].value ().c ()[0];
}

inline unsigned short
AtlantisOptions::optionGetGroundColorGreen ()
{
    return mOptions[AtlantisOptions::GroundColor].value ().c ()[1];
}


inline unsigned short
AtlantisOptions::optionGetGroundColorBlue ()
{
    return mOptions[AtlantisOptions::GroundColor].value ().c ()[2];
}


inline unsigned short
AtlantisOptions::optionGetGroundColorAlpha ()
{
    return mOptions[AtlantisOptions::GroundColor].value ().c ()[3];
}


inline void
AtlantisOptions::optionSetGroundColorNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::GroundColor] = notify;
}

inline float
AtlantisOptions::optionGetWaterHeight ()
{
    return mOptions[AtlantisOptions::WaterHeight].value ().f ();
}

inline void
AtlantisOptions::optionSetWaterHeightNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::WaterHeight] = notify;
}

inline unsigned short *
AtlantisOptions::optionGetWaterColor ()
{
    return mOptions[AtlantisOptions::WaterColor].value ().c ();
}

inline unsigned short
AtlantisOptions::optionGetWaterColorRed ()
{
    return mOptions[AtlantisOptions::WaterColor].value ().c ()[0];
}

inline unsigned short
AtlantisOptions::optionGetWaterColorGreen ()
{
    return mOptions[AtlantisOptions::WaterColor].value ().c ()[1];
}


inline unsigned short
AtlantisOptions::optionGetWaterColorBlue ()
{
    return mOptions[AtlantisOptions::WaterColor].value ().c ()[2];
}


inline unsigned short
AtlantisOptions::optionGetWaterColorAlpha ()
{
    return mOptions[AtlantisOptions::WaterColor].value ().c ()[3];
}


inline void
AtlantisOptions::optionSetWaterColorNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::WaterColor] = notify;
}

inline int
AtlantisOptions::optionGetGridQuality ()
{
    return mOptions[AtlantisOptions::GridQuality].value ().i ();
}

inline void
AtlantisOptions::optionSetGridQualityNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::GridQuality] = notify;
}

inline bool
AtlantisOptions::optionGetRenderWaves ()
{
    return mOptions[AtlantisOptions::RenderWaves].value ().b ();
}

inline void
AtlantisOptions::optionSetRenderWavesNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::RenderWaves] = notify;
}

inline bool
AtlantisOptions::optionGetWaveRipple ()
{
    return mOptions[AtlantisOptions::WaveRipple].value ().b ();
}

inline void
AtlantisOptions::optionSetWaveRippleNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::WaveRipple] = notify;
}

inline float
AtlantisOptions::optionGetWaveAmplitude ()
{
    return mOptions[AtlantisOptions::WaveAmplitude].value ().f ();
}

inline void
AtlantisOptions::optionSetWaveAmplitudeNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::WaveAmplitude] = notify;
}

inline float
AtlantisOptions::optionGetWaveFrequency ()
{
    return mOptions[AtlantisOptions::WaveFrequency].value ().f ();
}

inline void
AtlantisOptions::optionSetWaveFrequencyNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::WaveFrequency] = notify;
}

inline float
AtlantisOptions::optionGetSmallWaveAmplitude ()
{
    return mOptions[AtlantisOptions::SmallWaveAmplitude].value ().f ();
}

inline void
AtlantisOptions::optionSetSmallWaveAmplitudeNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::SmallWaveAmplitude] = notify;
}

inline float
AtlantisOptions::optionGetSmallWaveFrequency ()
{
    return mOptions[AtlantisOptions::SmallWaveFrequency].value ().f ();
}

inline void
AtlantisOptions::optionSetSmallWaveFrequencyNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::SmallWaveFrequency] = notify;
}

inline bool
AtlantisOptions::optionGetRescaleWidth ()
{
    return mOptions[AtlantisOptions::RescaleWidth].value ().b ();
}

inline void
AtlantisOptions::optionSetRescaleWidthNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::RescaleWidth] = notify;
}

inline bool
AtlantisOptions::optionGetRotateLighting ()
{
    return mOptions[AtlantisOptions::RotateLighting].value ().b ();
}

inline void
AtlantisOptions::optionSetRotateLightingNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::RotateLighting] = notify;
}

inline float
AtlantisOptions::optionGetLightInclination ()
{
    return mOptions[AtlantisOptions::LightInclination].value ().f ();
}

inline void
AtlantisOptions::optionSetLightInclinationNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::LightInclination] = notify;
}

inline float
AtlantisOptions::optionGetLightAmbient ()
{
    return mOptions[AtlantisOptions::LightAmbient].value ().f ();
}

inline void
AtlantisOptions::optionSetLightAmbientNotify (AtlantisOptions::ChangeNotify notify)
{
    mNotify[AtlantisOptions::LightAmbient] = notify;
}



#endif
