/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _TILE_OPTIONS_H
#define _TILE_OPTIONS_H

#include <core/core.h>

class TileOptions : public CompOption::Class {
    public:
        enum Options {
            AnimateType,
            AnimationDuration,
            TileToggleType,
            TileJoin,
            CascadeDelta,
            TileLeftOccupancy,
            ExcludeMatch,
            RestoreKey,
            SquareKey,
            EvenKey,
            HorizontalKey,
            VerticalKey,
            ExpandKey,
            OrganicKey,
            CascadeKey,
            RestoreEdge,
            SquareEdge,
            EvenEdge,
            HorizontalEdge,
            VerticalEdge,
            ExpandEdge,
            OrganicEdge,
            CascadeEdge,
            OptionNum
        };

        enum AnimateType {
            AnimateTypeNone = 0,
            AnimateTypeFilledOutline = 1,
            AnimateTypeSlide = 2,
            AnimateTypeZoom = 3,
            AnimateTypeDropFromTop = 4,
            AnimateTypeFade = 5,
        };

        enum TileToggleType {
            TileToggleTypeTile = 0,
            TileToggleTypeLeft = 1,
            TileToggleTypeTileVertically = 2,
            TileToggleTypeTileHorizontally = 3,
            TileToggleTypeCascade = 4,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        TileOptions ();
        virtual ~TileOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        int optionGetAnimateType ();
        void optionSetAnimateTypeNotify (ChangeNotify notify);

        int optionGetAnimationDuration ();
        void optionSetAnimationDurationNotify (ChangeNotify notify);

        int optionGetTileToggleType ();
        void optionSetTileToggleTypeNotify (ChangeNotify notify);

        bool optionGetTileJoin ();
        void optionSetTileJoinNotify (ChangeNotify notify);

        int optionGetCascadeDelta ();
        void optionSetCascadeDeltaNotify (ChangeNotify notify);

        int optionGetTileLeftOccupancy ();
        void optionSetTileLeftOccupancyNotify (ChangeNotify notify);

        CompMatch & optionGetExcludeMatch ();
        void optionSetExcludeMatchNotify (ChangeNotify notify);

        CompAction & optionGetRestoreKey ();
        void optionSetRestoreKeyInitiate (CompAction::CallBack init);
        void optionSetRestoreKeyTerminate (CompAction::CallBack term);
        void optionSetRestoreKeyNotify (ChangeNotify notify);

        CompAction & optionGetSquareKey ();
        void optionSetSquareKeyInitiate (CompAction::CallBack init);
        void optionSetSquareKeyTerminate (CompAction::CallBack term);
        void optionSetSquareKeyNotify (ChangeNotify notify);

        CompAction & optionGetEvenKey ();
        void optionSetEvenKeyInitiate (CompAction::CallBack init);
        void optionSetEvenKeyTerminate (CompAction::CallBack term);
        void optionSetEvenKeyNotify (ChangeNotify notify);

        CompAction & optionGetHorizontalKey ();
        void optionSetHorizontalKeyInitiate (CompAction::CallBack init);
        void optionSetHorizontalKeyTerminate (CompAction::CallBack term);
        void optionSetHorizontalKeyNotify (ChangeNotify notify);

        CompAction & optionGetVerticalKey ();
        void optionSetVerticalKeyInitiate (CompAction::CallBack init);
        void optionSetVerticalKeyTerminate (CompAction::CallBack term);
        void optionSetVerticalKeyNotify (ChangeNotify notify);

        CompAction & optionGetExpandKey ();
        void optionSetExpandKeyInitiate (CompAction::CallBack init);
        void optionSetExpandKeyTerminate (CompAction::CallBack term);
        void optionSetExpandKeyNotify (ChangeNotify notify);

        CompAction & optionGetOrganicKey ();
        void optionSetOrganicKeyInitiate (CompAction::CallBack init);
        void optionSetOrganicKeyTerminate (CompAction::CallBack term);
        void optionSetOrganicKeyNotify (ChangeNotify notify);

        CompAction & optionGetCascadeKey ();
        void optionSetCascadeKeyInitiate (CompAction::CallBack init);
        void optionSetCascadeKeyTerminate (CompAction::CallBack term);
        void optionSetCascadeKeyNotify (ChangeNotify notify);

        CompAction & optionGetRestoreEdge ();
        void optionSetRestoreEdgeInitiate (CompAction::CallBack init);
        void optionSetRestoreEdgeTerminate (CompAction::CallBack term);
        void optionSetRestoreEdgeNotify (ChangeNotify notify);

        CompAction & optionGetSquareEdge ();
        void optionSetSquareEdgeInitiate (CompAction::CallBack init);
        void optionSetSquareEdgeTerminate (CompAction::CallBack term);
        void optionSetSquareEdgeNotify (ChangeNotify notify);

        CompAction & optionGetEvenEdge ();
        void optionSetEvenEdgeInitiate (CompAction::CallBack init);
        void optionSetEvenEdgeTerminate (CompAction::CallBack term);
        void optionSetEvenEdgeNotify (ChangeNotify notify);

        CompAction & optionGetHorizontalEdge ();
        void optionSetHorizontalEdgeInitiate (CompAction::CallBack init);
        void optionSetHorizontalEdgeTerminate (CompAction::CallBack term);
        void optionSetHorizontalEdgeNotify (ChangeNotify notify);

        CompAction & optionGetVerticalEdge ();
        void optionSetVerticalEdgeInitiate (CompAction::CallBack init);
        void optionSetVerticalEdgeTerminate (CompAction::CallBack term);
        void optionSetVerticalEdgeNotify (ChangeNotify notify);

        CompAction & optionGetExpandEdge ();
        void optionSetExpandEdgeInitiate (CompAction::CallBack init);
        void optionSetExpandEdgeTerminate (CompAction::CallBack term);
        void optionSetExpandEdgeNotify (ChangeNotify notify);

        CompAction & optionGetOrganicEdge ();
        void optionSetOrganicEdgeInitiate (CompAction::CallBack init);
        void optionSetOrganicEdgeTerminate (CompAction::CallBack term);
        void optionSetOrganicEdgeNotify (ChangeNotify notify);

        CompAction & optionGetCascadeEdge ();
        void optionSetCascadeEdgeInitiate (CompAction::CallBack init);
        void optionSetCascadeEdgeTerminate (CompAction::CallBack term);
        void optionSetCascadeEdgeNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline int
TileOptions::optionGetAnimateType ()
{
    return mOptions[TileOptions::AnimateType].value ().i ();
}

inline void
TileOptions::optionSetAnimateTypeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::AnimateType] = notify;
}

inline int
TileOptions::optionGetAnimationDuration ()
{
    return mOptions[TileOptions::AnimationDuration].value ().i ();
}

inline void
TileOptions::optionSetAnimationDurationNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::AnimationDuration] = notify;
}

inline int
TileOptions::optionGetTileToggleType ()
{
    return mOptions[TileOptions::TileToggleType].value ().i ();
}

inline void
TileOptions::optionSetTileToggleTypeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::TileToggleType] = notify;
}

inline bool
TileOptions::optionGetTileJoin ()
{
    return mOptions[TileOptions::TileJoin].value ().b ();
}

inline void
TileOptions::optionSetTileJoinNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::TileJoin] = notify;
}

inline int
TileOptions::optionGetCascadeDelta ()
{
    return mOptions[TileOptions::CascadeDelta].value ().i ();
}

inline void
TileOptions::optionSetCascadeDeltaNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::CascadeDelta] = notify;
}

inline int
TileOptions::optionGetTileLeftOccupancy ()
{
    return mOptions[TileOptions::TileLeftOccupancy].value ().i ();
}

inline void
TileOptions::optionSetTileLeftOccupancyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::TileLeftOccupancy] = notify;
}

inline CompMatch &
TileOptions::optionGetExcludeMatch ()
{
    return mOptions[TileOptions::ExcludeMatch].value ().match ();
}

inline void
TileOptions::optionSetExcludeMatchNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::ExcludeMatch] = notify;
}

inline CompAction &
TileOptions::optionGetRestoreKey ()
{
    return mOptions[TileOptions::RestoreKey].value ().action ();
}

inline void
TileOptions::optionSetRestoreKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::RestoreKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetRestoreKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::RestoreKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetRestoreKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::RestoreKey] = notify;
}

inline CompAction &
TileOptions::optionGetSquareKey ()
{
    return mOptions[TileOptions::SquareKey].value ().action ();
}

inline void
TileOptions::optionSetSquareKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::SquareKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetSquareKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::SquareKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetSquareKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::SquareKey] = notify;
}

inline CompAction &
TileOptions::optionGetEvenKey ()
{
    return mOptions[TileOptions::EvenKey].value ().action ();
}

inline void
TileOptions::optionSetEvenKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::EvenKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetEvenKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::EvenKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetEvenKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::EvenKey] = notify;
}

inline CompAction &
TileOptions::optionGetHorizontalKey ()
{
    return mOptions[TileOptions::HorizontalKey].value ().action ();
}

inline void
TileOptions::optionSetHorizontalKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::HorizontalKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetHorizontalKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::HorizontalKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetHorizontalKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::HorizontalKey] = notify;
}

inline CompAction &
TileOptions::optionGetVerticalKey ()
{
    return mOptions[TileOptions::VerticalKey].value ().action ();
}

inline void
TileOptions::optionSetVerticalKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::VerticalKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetVerticalKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::VerticalKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetVerticalKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::VerticalKey] = notify;
}

inline CompAction &
TileOptions::optionGetExpandKey ()
{
    return mOptions[TileOptions::ExpandKey].value ().action ();
}

inline void
TileOptions::optionSetExpandKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::ExpandKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetExpandKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::ExpandKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetExpandKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::ExpandKey] = notify;
}

inline CompAction &
TileOptions::optionGetOrganicKey ()
{
    return mOptions[TileOptions::OrganicKey].value ().action ();
}

inline void
TileOptions::optionSetOrganicKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::OrganicKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetOrganicKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::OrganicKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetOrganicKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::OrganicKey] = notify;
}

inline CompAction &
TileOptions::optionGetCascadeKey ()
{
    return mOptions[TileOptions::CascadeKey].value ().action ();
}

inline void
TileOptions::optionSetCascadeKeyInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::CascadeKey].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetCascadeKeyTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::CascadeKey].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetCascadeKeyNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::CascadeKey] = notify;
}

inline CompAction &
TileOptions::optionGetRestoreEdge ()
{
    return mOptions[TileOptions::RestoreEdge].value ().action ();
}

inline void
TileOptions::optionSetRestoreEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::RestoreEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetRestoreEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::RestoreEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetRestoreEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::RestoreEdge] = notify;
}

inline CompAction &
TileOptions::optionGetSquareEdge ()
{
    return mOptions[TileOptions::SquareEdge].value ().action ();
}

inline void
TileOptions::optionSetSquareEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::SquareEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetSquareEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::SquareEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetSquareEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::SquareEdge] = notify;
}

inline CompAction &
TileOptions::optionGetEvenEdge ()
{
    return mOptions[TileOptions::EvenEdge].value ().action ();
}

inline void
TileOptions::optionSetEvenEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::EvenEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetEvenEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::EvenEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetEvenEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::EvenEdge] = notify;
}

inline CompAction &
TileOptions::optionGetHorizontalEdge ()
{
    return mOptions[TileOptions::HorizontalEdge].value ().action ();
}

inline void
TileOptions::optionSetHorizontalEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::HorizontalEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetHorizontalEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::HorizontalEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetHorizontalEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::HorizontalEdge] = notify;
}

inline CompAction &
TileOptions::optionGetVerticalEdge ()
{
    return mOptions[TileOptions::VerticalEdge].value ().action ();
}

inline void
TileOptions::optionSetVerticalEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::VerticalEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetVerticalEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::VerticalEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetVerticalEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::VerticalEdge] = notify;
}

inline CompAction &
TileOptions::optionGetExpandEdge ()
{
    return mOptions[TileOptions::ExpandEdge].value ().action ();
}

inline void
TileOptions::optionSetExpandEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::ExpandEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetExpandEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::ExpandEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetExpandEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::ExpandEdge] = notify;
}

inline CompAction &
TileOptions::optionGetOrganicEdge ()
{
    return mOptions[TileOptions::OrganicEdge].value ().action ();
}

inline void
TileOptions::optionSetOrganicEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::OrganicEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetOrganicEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::OrganicEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetOrganicEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::OrganicEdge] = notify;
}

inline CompAction &
TileOptions::optionGetCascadeEdge ()
{
    return mOptions[TileOptions::CascadeEdge].value ().action ();
}

inline void
TileOptions::optionSetCascadeEdgeInitiate (CompAction::CallBack init)
{
    mOptions[TileOptions::CascadeEdge].value ().action ().setInitiate (init);
}

inline void
TileOptions::optionSetCascadeEdgeTerminate (CompAction::CallBack term)
{
    mOptions[TileOptions::CascadeEdge].value ().action ().setTerminate (term);
}

inline void
TileOptions::optionSetCascadeEdgeNotify (TileOptions::ChangeNotify notify)
{
    mNotify[TileOptions::CascadeEdge] = notify;
}



#endif
